Radio = {};


function Radio.prerequisitesPresent(specializations)
      return true;
end;

function Radio:load(savegame)


    self.indoorCamIndex = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.indoorCamIndex"), 1);
    self.outdoorCamIndex = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.outdoorCamIndex"), 2);
    
self.sampleradio1 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.radio1", nil, self.baseDirectory);
self.sampleradio2 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.radio2", nil, self.baseDirectory);
self.sampleradio3 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.radio3", nil, self.baseDirectory);
self.sampleradio4 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.radio4", nil, self.baseDirectory);
self.sampleradio5 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.radio5", nil, self.baseDirectory);
self.sampleradio6 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.radio6", nil, self.baseDirectory);
self.sampleradio7 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.radio7", nil, self.baseDirectory);
self.sampleradio8 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.radio8", nil, self.baseDirectory);
self.sampleradio9 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.radio9", nil, self.baseDirectory);
self.sampleessuiglace = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.sampleessuiglace", nil, self.baseDirectory);
self.essuiglace = SoundUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.essuiglace#index"));

 self.temp = 0

    
end;

function Radio:delete()
end;

function Radio:readStream(streamId, connection)
end;
  
function Radio:writeStream(streamId, connection)
end;

function Radio:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Radio:keyEvent(unicode, sym, modifier, isDown)    
end;

function Radio:update(dt)
    local xporteG,yporteG,zporteG = getRotation(self.porteG);
    local xporteD,yporteD,zporteD = getRotation(self.porteD);
    
    if self.camIndex ~= nil then
        if self.camIndex == self.indoorCamIndex then
            SoundUtil.setSampleVolume(self.sampleradio1, 1);
            SoundUtil.setSampleVolume(self.sampleradio2, 1);
            SoundUtil.setSampleVolume(self.sampleradio3, 1);
            SoundUtil.setSampleVolume(self.sampleradio4, 1);
            SoundUtil.setSampleVolume(self.sampleradio5, 1);
            SoundUtil.setSampleVolume(self.sampleradio6, 1);
            SoundUtil.setSampleVolume(self.sampleradio7, 1);
            SoundUtil.setSampleVolume(self.sampleradio8, 1);
            SoundUtil.setSampleVolume(self.sampleradio9, 1);
            SoundUtil.setSampleVolume(self.sampleessuiglace, 0.2);
            if yporteG < 0.5 and yporteD > -0.5 then 
                SoundUtil.setSampleVolume(self.sampleHonk, 0.4);
                SoundUtil.setSampleVolume(self.sampleMotorStart, 0.1);
                SoundUtil.setSampleVolume(self.sampleralentifaible, 0.1);
                SoundUtil.setSampleVolume(self.sampleaccelerationfaible, 0.1);
                SoundUtil.setSampleVolume(self.sampleacceleration4faible, 0.1);
                SoundUtil.setSampleVolume(self.sampleacceleration5faible, 0.1);
                SoundUtil.setSampleVolume(self.sampleacceleration6faible, 0.1);
                SoundUtil.setSampleVolume(self.sampleregimehautfaible, 0.1);
                SoundUtil.setSampleVolume(self.sampledecelerationfaible, 0.1);
            else
                SoundUtil.setSampleVolume(self.sampleHonk, 1);
                SoundUtil.setSampleVolume(self.sampleMotorStart, 0.4);
                SoundUtil.setSampleVolume(self.sampleralentifaible, 0.4);
                SoundUtil.setSampleVolume(self.sampleaccelerationfaible, 0.4);
                SoundUtil.setSampleVolume(self.sampleacceleration4faible, 0.4);
                SoundUtil.setSampleVolume(self.sampleacceleration5faible, 0.4);
                SoundUtil.setSampleVolume(self.sampleacceleration6faible, 0.4);
                SoundUtil.setSampleVolume(self.sampleregimehautfaible, 0.4);
                SoundUtil.setSampleVolume(self.sampledecelerationfaible, 0.4);
            end;
        else
            SoundUtil.setSampleVolume(self.sampleradio1, 0);
            SoundUtil.setSampleVolume(self.sampleradio2, 0);
            SoundUtil.setSampleVolume(self.sampleradio3, 0);
            SoundUtil.setSampleVolume(self.sampleradio4, 0);
            SoundUtil.setSampleVolume(self.sampleradio5, 0);
            SoundUtil.setSampleVolume(self.sampleradio6, 0);
            SoundUtil.setSampleVolume(self.sampleradio7, 0);
            SoundUtil.setSampleVolume(self.sampleradio8, 0);
            SoundUtil.setSampleVolume(self.sampleradio9, 0);
            SoundUtil.setSampleVolume(self.sampleHonk, 2);
            SoundUtil.setSampleVolume(self.sampleMotorStart, 1);
        end;
    end;
    


end;

function Radio:updateTick(dt)

local xessuiglace,yessuiglace,zessuiglace = getRotation(self.essuiglace);
if self:getIsActive() then
    if yessuiglace > 0.05 and yessuiglace < 0.1 then 
        if not Utils.isSamplePlaying(self.sampleessuiglace) then 
            SoundUtil.playSample(self.sampleessuiglace, 1, 0, nil);
        end;
    end;
end;


    
    self.temp  =  self.temp + dt

if self:getIsActive() then
    if self:getIsActiveForSound() then
    
    if self.temp > 60000 then
    self.temp = 0
    end;
    
    if self.temp > 1000 and self.temp < 1050 then
    SoundUtil.playSample(self.sampleradio1, 1, 0, nil);
    end;
    
    if self.temp > 15000 and self.temp < 15050 then
    SoundUtil.playSample(self.sampleradio5, 1, 0, nil);
    end;
    
    if self.temp > 30000 and self.temp < 30050 then
    SoundUtil.playSample(self.sampleradio2, 1, 0, nil);
    end;
    
    if self.temp > 45000 and self.temp < 45050 then
    SoundUtil.playSample(self.sampleradio3, 1, 0, nil);
    end;
    
    if self.temp > 60000 and self.temp < 60050 then
    SoundUtil.playSample(self.sampleradio4, 1, 0, nil);
    end;
    
    if self.temp > 75000 and self.temp < 75050 then
    SoundUtil.playSample(self.sampleradio5, 1, 0, nil);
    end;
    
    if self.temp > 90000 and self.temp < 90050 then
    SoundUtil.playSample(self.sampleradio6, 1, 0, nil);
    end;
    
    if self.temp > 105000 and self.temp < 105050 then
    SoundUtil.playSample(self.sampleradio7, 1, 0, nil);
    end;
    
    if self.temp > 120000 and self.temp < 120050 then
    SoundUtil.playSample(self.sampleradio8, 1, 0, nil);
    end;
    
    if self.temp > 135000 and self.temp < 135050 then
    SoundUtil.playSample(self.sampleradio9, 1, 0, nil);
    end;
    
end;    
end;    
    

end;
    
function Radio:onLeave()
    SoundUtil.setSampleVolume(self.sampleessuiglace, 0);
    SoundUtil.setSampleVolume(self.sampleMotor, 0.8);
end;  
      
function Radio:draw()      
end;

function Radio:onDeactivateSounds()
end;

function Radio:onDeactivate()
end;




