Truckrpm = {};


    function Truckrpm.prerequisitesPresent(specializations)
        return SpecializationUtil.hasSpecialization(Drivable, specializations);
    end;
    
    function Truckrpm:load(savegame)
    
    self.leviervitesse = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.leviervitesse#index"));

    self.vitessesup = SpecializationUtil.callSpecializationsFunction("vitessesup");
    self.acceleration = SpecializationUtil.callSpecializationsFunction("acceleration");
    self.regimehaut = SpecializationUtil.callSpecializationsFunction("regimehaut");

    self.sampleralenti = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.ralentiSound", nil, self.baseDirectory);
    self.sampleregimehaut = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.regimehautSound", nil, self.baseDirectory);
    
    self.sampleacceleration = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.accelerationSound", nil, self.baseDirectory);
    self.sampleacceleration4 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.acceleration4Sound", nil, self.baseDirectory);
    self.sampleacceleration5 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.acceleration5Sound", nil, self.baseDirectory);
    self.sampleacceleration6 = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.acceleration6Sound", nil, self.baseDirectory);
    
    self.sampledeceleration = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.decelerationSound", nil, self.baseDirectory);

    self.vitessesup = SpecializationUtil.callSpecializationsFunction("vitessesup");
    self.acceleration = SpecializationUtil.callSpecializationsFunction("acceleration");
    self.regimehaut = SpecializationUtil.callSpecializationsFunction("regimehaut");

    self.sampleralentifaible = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.faibleralentiSound", nil, self.baseDirectory);
    self.sampleregimehautfaible = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.faibleregimehautSound", nil, self.baseDirectory);
    
    self.sampleaccelerationfaible = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.faibleaccelerationSound", nil, self.baseDirectory);
    self.sampleacceleration4faible = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.faibleacceleration4Sound", nil, self.baseDirectory);
    self.sampleacceleration5faible = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.faibleacceleration5Sound", nil, self.baseDirectory);
    self.sampleacceleration6faible = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.faibleacceleration6Sound", nil, self.baseDirectory);
    
    self.sampledecelerationfaible = SoundUtil.loadSample(self.xmlFile, {}, "vehicle.faibledecelerationSound", nil, self.baseDirectory);
    
    self.conteur = 0
    self.conteur2 = 0
    self.conteur3 = 1



    end;
    
    function Truckrpm:delete()
    SoundUtil.deleteSample(self.sampleralenti, true);
    SoundUtil.deleteSample(self.sampleacceleration, true);
    SoundUtil.deleteSample(self.sampleacceleration4, true);
    SoundUtil.deleteSample(self.sampleacceleration5, true);
    SoundUtil.deleteSample(self.sampleacceleration6, true);    
    SoundUtil.deleteSample(self.sampleregimehaut, true);    
    SoundUtil.deleteSample(self.sampledeceleration, true);
    
    SoundUtil.deleteSample(self.sampleralentifaible, true);
    SoundUtil.deleteSample(self.sampleaccelerationfaible, true);
    SoundUtil.deleteSample(self.sampleacceleration4faible, true);
    SoundUtil.deleteSample(self.sampleacceleration5faible, true);
    SoundUtil.deleteSample(self.sampleacceleration6faible, true);    
    SoundUtil.deleteSample(self.sampleregimehautfaible, true);    
    SoundUtil.deleteSample(self.sampledecelerationfaible, true);
    

    end;
    
    function Truckrpm:readStream(streamId, connection)
    end;
    
    function Truckrpm:writeStream(streamId, connection)
    end;
    
    function Truckrpm:mouseEvent(posX, posY, isDown, isUp, button)
    end;
    
    function Truckrpm:keyEvent(unicode, sym, modifier, isDown)
    end;
    


function Truckrpm:update(dt)
    
    if self.movingDirection == -1 then    
        setRotation(self.leviervitesse, -0.0872665, 0, 0);
        if self.characterRightArmIKChainId ~= nil then
            IKUtil.setIKChainDirty(self.ikChainsById, self.characterRightArmIKChainId);
        end;
    end;
    if self.movingDirection == 0 then    
        setRotation(self.leviervitesse, 0, 0, 0);
        if self.characterRightArmIKChainId ~= nil then
            IKUtil.setIKChainDirty(self.ikChainsById, self.characterRightArmIKChainId);
        end;
    end;

local KMH = g_i18n:getSpeed(self:getLastSpeed() * self.speedDisplayScale)
if  KMH >= 0 and KMH <= 23 then
    self.conteur3 = 1
    if self.movingDirection == 1 then    
        setRotation(self.leviervitesse, 0.0872665, 0, 0);
        if self.characterRightArmIKChainId ~= nil then
            IKUtil.setIKChainDirty(self.ikChainsById, self.characterRightArmIKChainId);
        end;
    end;
end;
if  KMH > 23 and KMH <= 35 then
    self.conteur3 = 2 
    if self.movingDirection == 1 then
    setRotation(self.leviervitesse, 0.174533, 0, 0);
        if self.characterRightArmIKChainId ~= nil then
            IKUtil.setIKChainDirty(self.ikChainsById, self.characterRightArmIKChainId);
        end;
    end;
end;
if  KMH > 35 and KMH <= 45 then
    self.conteur3 = 3 
    if self.movingDirection == 1 then
    setRotation(self.leviervitesse, 0.261799, 0, 0);
        if self.characterRightArmIKChainId ~= nil then
            IKUtil.setIKChainDirty(self.ikChainsById, self.characterRightArmIKChainId);
        end;
    end;
end;
if  KMH > 45 and KMH <= 65 then
    self.conteur3 = 4 
    if self.movingDirection == 1 then
    setRotation(self.leviervitesse, 0.349066, 0, 0);
        if self.characterRightArmIKChainId ~= nil then
            IKUtil.setIKChainDirty(self.ikChainsById, self.characterRightArmIKChainId);
        end;
    end;
end;
if  KMH > 65 and KMH <= 80 then
    self.conteur3 = 5
    if self.movingDirection == 1 then
    setRotation(self.leviervitesse, 0.436332, 0, 0);
        if self.characterRightArmIKChainId ~= nil then
            IKUtil.setIKChainDirty(self.ikChainsById, self.characterRightArmIKChainId);
        end;    
    end;
end;
if  KMH > 80 and KMH <= 100 then
    self.conteur3 = 6 
end;

if self.isMotorStarted then
    if self.isEntered and self.isClient then
        if self:getIsActiveForSound() then    
            if InputBinding.hasEvent(InputBinding.CAMERA_SWITCH) then
                if self.axisForward < 0 then
                    if not SoundUtil.isSamplePlaying(self.sampledeceleration, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampledecelerationfaible, 1.5*dt) then
                        self:acceleration();
                    end;
                end;
            end;
            
            if self.camIndex == self.outdoorCamIndex then

            SoundUtil.deleteSample(self.sampleralentifaible, true);
            SoundUtil.deleteSample(self.sampleaccelerationfaible, true);
            SoundUtil.deleteSample(self.sampleacceleration4faible, true);
            SoundUtil.deleteSample(self.sampleacceleration5faible, true);
            SoundUtil.deleteSample(self.sampleacceleration6faible, true);    
            SoundUtil.deleteSample(self.sampleregimehautfaible, true);    
            SoundUtil.deleteSample(self.sampledecelerationfaible, true);    

            if not SoundUtil.isSamplePlaying(self.sampleMotorStart, 1.5*dt) then
                if self.axisForward >= 0 then
                    if not SoundUtil.isSamplePlaying(self.sampleregimehaut, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampledeceleration, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration6, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration5, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration4, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration, 1.5*dt) then
                        SoundUtil.playSample(self.sampleralenti, 0, 0, nil);
                    
                        self.conteur = 0
                        SoundUtil.deleteSample(self.sampleacceleration, true);
                        SoundUtil.deleteSample(self.sampleacceleration4, true);
                        SoundUtil.deleteSample(self.sampleacceleration5, true);
                        SoundUtil.deleteSample(self.sampleacceleration6, true);
                        SoundUtil.deleteSample(self.sampleregimehaut, true);    
                        SoundUtil.deleteSample(self.sampledeceleration, true);
                    else
                        if not SoundUtil.isSamplePlaying(self.sampledeceleration, 1.5*dt) then
                            self:vitessesup();
                        end;                    
                    end;
                end;
                if self.axisForward < 0 then
                    if not SoundUtil.isSamplePlaying(self.sampledeceleration, 1.5*dt) then
                        if    self.conteur == 0 and self.conteur2 == 0 then
                            self:acceleration();
                        end;
                    end;
                    if    self.conteur == 1 and self.conteur2 == 0 then
                        if not SoundUtil.isSamplePlaying(self.sampleacceleration, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration4, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration5, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration6, 1.5*dt) then
                            self:regimehaut();
                        end;
                    end;
                    if self.conteur2 == 1 then
                        if not SoundUtil.isSamplePlaying(self.sampledeceleration, 1.5*dt) then
                            self:vitessesup();
                        end;
                    end;
                end;
            end;
            if self.conteur2 == 0 then
                local KMH = g_i18n:getSpeed(self:getLastSpeed() * self.speedDisplayScale)
                if not SoundUtil.isSamplePlaying(self.sampledeceleration, 1.5*dt) then
                    if ( KMH > 23 and KMH < 23.1 ) or ( KMH > 35 and KMH < 35.1 ) or ( KMH > 45 and KMH < 45.1 ) or ( KMH > 65 and KMH < 65.1 ) then
            
                        self.conteur2 = 1 
                    end;
                end;
            end;
            
            
            else
            
            SoundUtil.deleteSample(self.sampleralenti, true);
            SoundUtil.deleteSample(self.sampleacceleration, true);
            SoundUtil.deleteSample(self.sampleacceleration4, true);
            SoundUtil.deleteSample(self.sampleacceleration5, true);
            SoundUtil.deleteSample(self.sampleacceleration6, true);    
            SoundUtil.deleteSample(self.sampleregimehaut, true);    
            SoundUtil.deleteSample(self.sampledeceleration, true);
        
            if not SoundUtil.isSamplePlaying(self.sampleMotorStart, 1.5*dt) then
                if self.axisForward >= 0 then
                    if not SoundUtil.isSamplePlaying(self.sampleregimehautfaible, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampledecelerationfaible, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration6faible, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration5faible, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration4faible, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleaccelerationfaible, 1.5*dt) then
                        SoundUtil.playSample(self.sampleralentifaible, 0, 0, nil);
                
                        self.conteur = 0
                        SoundUtil.deleteSample(self.sampleaccelerationfaible, true);
                        SoundUtil.deleteSample(self.sampleacceleration4faible, true);
                        SoundUtil.deleteSample(self.sampleacceleration5faible, true);
                        SoundUtil.deleteSample(self.sampleacceleration6faible, true);
                        SoundUtil.deleteSample(self.sampleregimehautfaible, true);    
                        SoundUtil.deleteSample(self.sampledecelerationfaible, true);
                    else
                        if not SoundUtil.isSamplePlaying(self.sampledecelerationfaible, 1.5*dt) then
                            self:vitessesup();
                        end;                    
                    end;
                end;
                if self.axisForward < 0 then
                    if not SoundUtil.isSamplePlaying(self.sampledecelerationfaible, 1.5*dt) then
                        if    self.conteur == 0 and self.conteur2 == 0 then
                            self:acceleration();
                        end;
                    end;
                    if    self.conteur == 1 and self.conteur2 == 0 then
                        if not SoundUtil.isSamplePlaying(self.sampleaccelerationfaible, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration4faible, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration5faible, 1.5*dt) and not SoundUtil.isSamplePlaying(self.sampleacceleration6faible, 1.5*dt) then
                            self:regimehaut();
                        end;
                    end;
                    if self.conteur2 == 1 then
                        if not SoundUtil.isSamplePlaying(self.sampledecelerationfaible, 1.5*dt) then
                            self:vitessesup();
                        end;
                    end;
                end;
            end;
            if self.conteur2 == 0 then
                local KMH = g_i18n:getSpeed(self:getLastSpeed() * self.speedDisplayScale)
                if not SoundUtil.isSamplePlaying(self.sampledecelerationfaible, 1.5*dt) then
                    if ( KMH > 23 and KMH < 23.1 ) or ( KMH > 35 and KMH < 35.1 ) or ( KMH > 45 and KMH < 45.1 ) or ( KMH > 65 and KMH < 65.1 ) then
        
                        self.conteur2 = 1 
                    end;
                end;
            end;
        end;    
            
            
            
            
            
            
        end;
    end;        
else
    SoundUtil.deleteSample(self.sampleralenti, true);
    SoundUtil.deleteSample(self.sampleacceleration, true);
    SoundUtil.deleteSample(self.sampleacceleration4, true);
    SoundUtil.deleteSample(self.sampleacceleration5, true);
    SoundUtil.deleteSample(self.sampleacceleration6, true);    
    SoundUtil.deleteSample(self.sampleregimehaut, true);    
    SoundUtil.deleteSample(self.sampledeceleration, true);
    
    SoundUtil.deleteSample(self.sampleralentifaible, true);
    SoundUtil.deleteSample(self.sampleaccelerationfaible, true);
    SoundUtil.deleteSample(self.sampleacceleration4faible, true);
    SoundUtil.deleteSample(self.sampleacceleration5faible, true);
    SoundUtil.deleteSample(self.sampleacceleration6faible, true);    
    SoundUtil.deleteSample(self.sampleregimehautfaible, true);    
    SoundUtil.deleteSample(self.sampledecelerationfaible, true);
end;
end;
    
    function Truckrpm:updateTick(dt)
    end;
    
    function Truckrpm:draw()
    end;
    
    function Truckrpm:acceleration()
            if self.isClient then
                SoundUtil.deleteSample(self.sampleralenti, true);
                SoundUtil.deleteSample(self.sampleregimehaut, true);    
                SoundUtil.deleteSample(self.sampledeceleration, true);
                
                SoundUtil.deleteSample(self.sampleralentifaible, true);
                SoundUtil.deleteSample(self.sampleregimehautfaible, true);    
                SoundUtil.deleteSample(self.sampledecelerationfaible, true);
                
                    if self:getIsActiveForSound() then
                        if self.camIndex == self.outdoorCamIndex then
                            if self.conteur3 ==  1 then
                                SoundUtil.playSample(self.sampleacceleration, 1, 0, nil);
                                self.conteur = 1
                                
                            end;
                            if self.conteur3 ==  2 then
                                SoundUtil.playSample(self.sampleacceleration4, 1, 0, nil);
                                self.conteur = 1
                                
                            end;
                            if self.conteur3 ==  3 then
                                SoundUtil.playSample(self.sampleacceleration5, 1, 0, nil);
                                self.conteur = 1
                            
                            end;
                            if self.conteur3 ==  4 then
                                SoundUtil.playSample(self.sampleacceleration6, 1, 0, nil);
                                self.conteur = 1
                            
                            end;
                            if self.conteur3 ==  5 then
                                SoundUtil.playSample(self.sampleacceleration6, 1, 0, nil);
                                self.conteur = 1
                            
                            end;
                            if self.conteur3 ==  6 then
                                SoundUtil.playSample(self.sampleacceleration6, 1, 0, nil);
                                self.conteur = 1
                            
                            end;
                        else
                            
                            if self.conteur3 ==  1 then
                                SoundUtil.playSample(self.sampleaccelerationfaible, 1, 0, nil);
                                self.conteur = 1
                                
                            end;
                            if self.conteur3 ==  2 then
                                SoundUtil.playSample(self.sampleacceleration4faible, 1, 0, nil);
                                self.conteur = 1
                            
                            end;
                            if self.conteur3 ==  3 then
                                SoundUtil.playSample(self.sampleacceleration5faible, 1, 0, nil);
                                self.conteur = 1
                            
                            end;
                            if self.conteur3 ==  4 then
                                SoundUtil.playSample(self.sampleacceleration6faible, 1, 0, nil);
                                self.conteur = 1
                            
                            end;
                            if self.conteur3 ==  5 then
                                SoundUtil.playSample(self.sampleacceleration6faible, 1, 0, nil);
                                self.conteur = 1
                            
                            end;
                            if self.conteur3 ==  6 then
                                SoundUtil.playSample(self.sampleacceleration6faible, 1, 0, nil);
                                self.conteur = 1
                            
                            end;
                        end;
                    end;
            end;
    end;

    function Truckrpm:regimehaut()
            if self.isClient then
                SoundUtil.deleteSample(self.sampleralenti, true);
                SoundUtil.deleteSample(self.sampleacceleration, true);
                SoundUtil.deleteSample(self.sampleacceleration4, true);
                SoundUtil.deleteSample(self.sampleacceleration5, true);
                SoundUtil.deleteSample(self.sampleacceleration6, true);
                SoundUtil.deleteSample(self.sampledeceleration, true);
                SoundUtil.deleteSample(self.sampleralentifaible, true);
                
                SoundUtil.deleteSample(self.sampleralentifaible, true);
                SoundUtil.deleteSample(self.sampleaccelerationfaible, true);
                SoundUtil.deleteSample(self.sampleacceleration4faible, true);
                SoundUtil.deleteSample(self.sampleacceleration5faible, true);
                SoundUtil.deleteSample(self.sampleacceleration6faible, true);
                SoundUtil.deleteSample(self.sampledecelerationfaible, true);
                
                if self:getIsActiveForSound() then
                    if self.camIndex == self.outdoorCamIndex then
                        SoundUtil.playSample(self.sampleregimehaut, 0, 0, nil);
                    
                    else
                        SoundUtil.playSample(self.sampleregimehautfaible, 0, 0, nil);
                        
                    end;
                end;
            end;
    end;

    function Truckrpm:vitessesup()
            if self.isClient then
                SoundUtil.deleteSample(self.sampleralenti, true);
                SoundUtil.deleteSample(self.sampleacceleration, true);
                SoundUtil.deleteSample(self.sampleacceleration4, true);
                SoundUtil.deleteSample(self.sampleacceleration5, true);
                SoundUtil.deleteSample(self.sampleacceleration6, true);
                SoundUtil.deleteSample(self.sampleregimehaut, true);

                SoundUtil.deleteSample(self.sampleralentifaible, true);
                SoundUtil.deleteSample(self.sampleaccelerationfaible, true);
                SoundUtil.deleteSample(self.sampleacceleration4faible, true);
                SoundUtil.deleteSample(self.sampleacceleration5faible, true);
                SoundUtil.deleteSample(self.sampleacceleration6faible, true);
                SoundUtil.deleteSample(self.sampleregimehautfaible, true);
                
                if self:getIsActiveForSound() then
                    if self.camIndex == self.outdoorCamIndex then
                        SoundUtil.playSample(self.sampledeceleration, 1, 0, nil);
                    
                        self.conteur2 = 0
                        self.conteur = 0
                    else
                        SoundUtil.playSample(self.sampledecelerationfaible, 1, 0, nil);
                    
                        self.conteur2 = 0
                        self.conteur = 0
                    end;                    
                end;
            end;
    end;
    
function Truckrpm:onDeactivateSounds()
    
    SoundUtil.deleteSample(self.sampleralenti, true);
    SoundUtil.deleteSample(self.sampleacceleration, true);
    SoundUtil.deleteSample(self.sampleacceleration4, true);
    SoundUtil.deleteSample(self.sampleacceleration5, true);
    SoundUtil.deleteSample(self.sampleacceleration6, true);    
    SoundUtil.deleteSample(self.sampleregimehaut, true);    
    SoundUtil.deleteSample(self.sampledeceleration, true);
    
    SoundUtil.deleteSample(self.sampleralentifaible, true);
    SoundUtil.deleteSample(self.sampleaccelerationfaible, true);
    SoundUtil.deleteSample(self.sampleacceleration4faible, true);
    SoundUtil.deleteSample(self.sampleacceleration5faible, true);
    SoundUtil.deleteSample(self.sampleacceleration6faible, true);    
    SoundUtil.deleteSample(self.sampleregimehautfaible, true);    
    SoundUtil.deleteSample(self.sampledecelerationfaible, true);
end;

    
